<?php
// Knowledgetree is published under the GNU GPL! Read LICENSE
// Frank Habermann <lordlamer@lordlamer.de>
// Robert Scholz <scholzrobert@web.de>

$version = "0.9.6";

require_once("include/class-tree.php");
require_once("config.php");
require_once("include/function.php");
require_once("include/class-knowledgeroot.php");
require_once("language/language.php");
require_once("include/fckeditor.php");

if($dbtype == "mysql") {
	require_once("include/class-mysql.php");
}

if($dbtype == "mysqli") {
	require_once("include/class-mysqli.php");
}

if($dbtype == "pgsql") {
	require_once("include/class-pgsql.php");
}

if($KNOWLEDGEROOTDB != "PGSQL" && $KNOWLEDGEROOTDB != "MYSQL") {
	echo "WRONG DBTYPE SELECTED!\n";
	exit();
}

$db = new db();

$db->connect($dbhost,$dbuser,$dbpass,$dbdatabase);

if($dbtype == "pgsql") {
	$db->schema($dbschema);
	$db->set_client_encoding($dbencoding);
}

$knowledgeroot = new knowledgeroot();
$knowledgeroot->start($db,$_SESSION['userid'],$_SESSION['groupid'],$languagetoken[$language], $dbtype);

session_name("sessionid");
session_start();

//check if userid and groupid is set, if not set to 0
if($_SESSION['userid'] == "" || $_SESSION['groupid'] == "") {
	$_SESSION['userid'] = 0;
	$_SESSION['groupid'] = 0;
}

if($_SESSION['firstrun'] == "" && $expandall == 1) {
	$doexpand = 1;
} else {
	$doexpand = 0;
}

if($HTTP_GET_VARS['id'] != "") {
	$id = $HTTP_GET_VARS['id'];
} else {
	$id = $HTTP_POST_VARS['id'];
}

if($id != "") {
	$_SESSION['cid'] = $id;
	//echo $_SESSION['cid'];
}

if($HTTP_GET_VARS['action'] == "logout") {
		$_SESSION['user'] = "guest";
		$_SESSION['password'] = "guest";
		$_SESSION['md5hash'] = "";
		$_SESSION['cid'] = "";
		$_SESSION['userid'] = "";
		$_SESSION['groupid'] = "";
		$_SESSION['admin'] = "0";
		$treecache = $_SESSION['open'];
		session_destroy();
		$_SESSION['open'] = $treecache;
}

if($_SESSION['user'] != "guest" && $_SESSION['password'] != "guest" && $_SESSION['md5hash'] != md5($_SESSION['user'] . $_SESSION['password'])) {
		$_SESSION['user'] = "guest";
		$_SESSION['password'] = "guest";
		$_SESSION['md5hash'] = "";
		$_SESSION['admin'] = "0";
}

if($HTTP_POST_VARS['login'] != "") {
	$user = addslashes($HTTP_POST_VARS['user']);
	$pass = md5(addslashes($HTTP_POST_VARS['password']));

	$res = $db->query("SELECT id, defaultgroup, admin, rightedit, treecache FROM users WHERE name='$user' and password='$pass' and enabled=1");
	$anz = $db->num_rows($res);
	
	if($anz == 1) {
		$row = $db->fetch_assoc($res);
		$_SESSION['userid'] = $row['id'];
		$_SESSION['groupid'] = $row['defaultgroup'];
		$_SESSION['user'] = $user;
		$_SESSION['password'] = $pass;
		$_SESSION['md5hash'] = md5($user . $pass);
		$_SESSION['admin'] = $row['admin'];
		$_SESSION['rightedit'] = $row['rightedit'];
		$_SESSION['open'] = array();
		$_SESSION['open'] = unserialize($row['treecache']);
	} else {
		$_SESSION['user'] = "guest";
		$_SESSION['password'] = "guest";
	}
}

if($_GET['download'] != "") {
	$rs = $db->query("select * from files where id =".$_GET['download'].";");
	$anz = $db->num_rows($rs);
	
	if($anz != 1) {
		echo "WRONG DOWNLOADFILE!\n";
		exit();
	}
	
	$row = $db->fetch_assoc($rs);

	if($knowledgeroot->checkRecursivPerm($row['belongs_to'], $_SESSION['userid']) != 0) {
		echo "No File for you!\n";
		exit();
	}
	
	header('Accept-Ranges: bytes');
	header('Content-Length: '.$row['filesize'].'');
	header('Keep-Alive: timeout=15, max=100');
	header('Content-type: '.$row['filetype'].'');
	header('Content-Disposition: attachment; filename="'.$row['filename'].'"');

	if($dbtype == "pgsql") {
		$db->query ("begin");
		$loid = $db->lo_open($row['object'], "r");
		$db->lo_read_all ($loid);
		$db->lo_close ($loid);
		$db->query ("commit");
		$db->close();
	}
	
	if($dbtype == "mysql") {
		echo unserialize($row['file']);
	}
	

	exit();
}

// if readonly than disable
if($readonly == 0) {
	if($HTTP_POST_VARS['submit'] && $HTTP_POST_VARS['editid']) {
		if($knowledgeroot->getPageRights($_SESSION['cid'],$_SESSION['userid']) == 2 && $knowledgeroot->getContentRights($HTTP_POST_VARS['editid'],$_SESSION['userid']) == 2) {
			if($HTTP_POST_VARS['close'] == "") {
				$content = stripslashes($content);
				
				if($_SESSION['rightedit'] == 1) {
					if($dbtype == "pgsql") {
						$res = $db->query("UPDATE content SET content='".$HTTP_POST_VARS['content']."', owner='".$HTTP_POST_VARS['user']."', \"group\"='".$HTTP_POST_VARS['group']."', userrights='".$HTTP_POST_VARS['userrights']."', grouprights='".$HTTP_POST_VARS['grouprights']."', otherrights='".$HTTP_POST_VARS['otherrights']."' WHERE id='".$HTTP_POST_VARS['editid']."'");
					} else {
						$res = $db->query("UPDATE content SET content='".$HTTP_POST_VARS['content']."', owner='".$HTTP_POST_VARS['user']."', `group`='".$HTTP_POST_VARS['group']."', userrights='".$HTTP_POST_VARS['userrights']."', grouprights='".$HTTP_POST_VARS['grouprights']."', otherrights='".$HTTP_POST_VARS['otherrights']."' WHERE id='".$HTTP_POST_VARS['editid']."'");
					}
				} else {
					$res = $db->query("UPDATE content SET content='".$HTTP_POST_VARS['content']."' WHERE id='".$HTTP_POST_VARS['editid']."'");
				}
				
				if($HTTP_POST_VARS['save'] != "") {
					$HTTP_GET_VARS['eid'] = $HTTP_POST_VARS['editid'];
				}
			}
		}
	}
	
	if($HTTP_POST_VARS['submit'] && $HTTP_POST_VARS['neditid']) {
		if($knowledgeroot->getPageRights($HTTP_POST_VARS['belongsto'],$_SESSION['userid']) == 2) {
			if($HTTP_POST_VARS['close'] == "") {
				$content = stripslashes($content);
				
				if($_SESSION['rightedit'] == 1) {
					if($dbtype == "pgsql") {
						$res = $db->query("INSERT INTO content (belongs_to, content,owner,\"group\",userrights,grouprights,otherrights) VALUES(".$HTTP_POST_VARS['belongsto'].", '".$HTTP_POST_VARS['content']."', '".$HTTP_POST_VARS['user']."', '".$HTTP_POST_VARS['group']."', '".$HTTP_POST_VARS['userrights']."', '".$HTTP_POST_VARS['grouprights']."', '".$HTTP_POST_VARS['otherrights']."')");
					} else {
						$res = $db->query("INSERT INTO content (belongs_to, content,owner,`group`,userrights,grouprights,otherrights) VALUES(".$HTTP_POST_VARS['belongsto'].", '".$HTTP_POST_VARS['content']."', '".$HTTP_POST_VARS['user']."', '".$HTTP_POST_VARS['group']."', '".$HTTP_POST_VARS['userrights']."', '".$HTTP_POST_VARS['grouprights']."', '".$HTTP_POST_VARS['otherrights']."')");
					}
				} else {
					if(!empty($_SESSION['userid'])) {
						// user logged in but have no rightedit -> use defaultrights
						$res = $db->query("SELECT id,defaultgroup,defaultrights FROM users WHERE id=".$_SESSION['userid']."");
						$anz = $db->num_rows($res);
						
						if($anz == 1) {
							$row = $db->fetch_assoc($res);
							if($dbtype == "pgsql") {
								$res = $db->query("INSERT INTO content (belongs_to, content,owner,\"group\",userrights,grouprights,otherrights) VALUES(".$HTTP_POST_VARS['belongsto'].", '".$HTTP_POST_VARS['content']."', '".$row['id']."', '".$row['defaultgroup']."', '".substr($row['defaultrights'],0,1)."', '".substr($row['defaultrights'],1,1)."', '".substr($row['defaultrights'],2,1)."')");
							} else {
								$res = $db->query("INSERT INTO content (belongs_to, content,owner,`group`,userrights,grouprights,otherrights) VALUES(".$HTTP_POST_VARS['belongsto'].", '".$HTTP_POST_VARS['content']."', '".$row['id']."', '".$row['defaultgroup']."', '".substr($row['defaultrights'],0,1)."', '".substr($row['defaultrights'],1,1)."', '".substr($row['defaultrights'],2,1)."')");
							}
						} else {
							if($dbtype == "pgsql") {
								$res = $db->query("INSERT INTO content (belongs_to, content,owner,\"group\",userrights,grouprights,otherrights) VALUES(".$HTTP_POST_VARS['belongsto'].", '".$HTTP_POST_VARS['content']."', '0', '0', '2', '2', '2')");
							} else {
								$res = $db->query("INSERT INTO content (belongs_to, content,owner,`group`,userrights,grouprights,otherrights) VALUES(".$HTTP_POST_VARS['belongsto'].", '".$HTTP_POST_VARS['content']."', '0', '0', '2', '2', '2')");
							}
						}
					} else {
						// no user logged in
						if($dbtype == "pgsql") {
							$res = $db->query("INSERT INTO content (belongs_to, content,owner,\"group\",userrights,grouprights,otherrights) VALUES(".$HTTP_POST_VARS['belongsto'].", '".$HTTP_POST_VARS['content']."', '0', '0', '2', '2', '2')");
						} else {
							$res = $db->query("INSERT INTO content (belongs_to, content,owner,`group`,userrights,grouprights,otherrights) VALUES(".$HTTP_POST_VARS['belongsto'].", '".$HTTP_POST_VARS['content']."', '0', '0', '2', '2', '2')");
						}
					}
				}
				
				if($HTTP_POST_VARS['save'] != "") {
					$HTTP_GET_VARS['eid'] = $db->last_id("seq_knowledge");
				}	
			}
		}
	}
	
	if($HTTP_POST_VARS['submit'] && $HTTP_POST_VARS['newpage']) {
		if($knowledgeroot->getPageRights($HTTP_POST_VARS['belongsto'],$_SESSION['userid']) == 2 && $HTTP_POST_VARS['title'] != "") {
			if($_SESSION['rightedit'] == 1) {
				//change this for mysql
				if($dbtype == "pgsql") {
					$res = $db->query("INSERT INTO tree (belongs_to,title,owner,\"group\",userrights,grouprights,otherrights) VALUES ('".$HTTP_POST_VARS['belongsto']."','".$HTTP_POST_VARS['title']."', '".$HTTP_POST_VARS['user']."', '".$HTTP_POST_VARS['group']."', '".$HTTP_POST_VARS['userrights']."', '".$HTTP_POST_VARS['grouprights']."', '".$HTTP_POST_VARS['otherrights']."')");
				} else {
					$res = $db->query("INSERT INTO tree (belongs_to,title,owner,`group`,userrights,grouprights,otherrights) VALUES ('".$HTTP_POST_VARS['belongsto']."','".$HTTP_POST_VARS['title']."', '".$HTTP_POST_VARS['user']."', '".$HTTP_POST_VARS['group']."', '".$HTTP_POST_VARS['userrights']."', '".$HTTP_POST_VARS['grouprights']."', '".$HTTP_POST_VARS['otherrights']."')");
				}
			} else {
				if(!empty($_SESSION['userid'])) {
					// user logged in but have no rightedit -> use defaultrights
					$res = $db->query("SELECT id,defaultgroup,defaultrights FROM users WHERE id=".$_SESSION['userid']."");
					$anz = $db->num_rows($res);
					
					if($anz == 1) {
						$row = $db->fetch_assoc($res);
						if($dbtype == "pgsql") {
							$res = $db->query("INSERT INTO tree (belongs_to,title,owner,\"group\",userrights,grouprights,otherrights) VALUES ('".$HTTP_POST_VARS['belongsto']."','".$HTTP_POST_VARS['title']."', '".$row['id']."', '".$row['defaultgroup']."', '".substr($row['defaultrights'],0,1)."', '".substr($row['defaultrights'],1,1)."', '".substr($row['defaultrights'],2,1)."')");
						} else {
							$res = $db->query("INSERT INTO tree (belongs_to,title,owner,`group`,userrights,grouprights,otherrights) VALUES ('".$HTTP_POST_VARS['belongsto']."','".$HTTP_POST_VARS['title']."', '".$row['id']."', '".$row['defaultgroup']."', '".substr($row['defaultrights'],0,1)."', '".substr($row['defaultrights'],1,1)."', '".substr($row['defaultrights'],2,1)."')");
						}
					} else {
						if($dbtype == "pgsql") {
							$res = $db->query("INSERT INTO tree (belongs_to,title,owner,\"group\",userrights,grouprights,otherrights) VALUES ('".$HTTP_POST_VARS['belongsto']."','".$HTTP_POST_VARS['title']."', '0', '0', '2', '2', '2')");
						} else {
							$res = $db->query("INSERT INTO tree (belongs_to,title,owner,`group`,userrights,grouprights,otherrights) VALUES ('".$HTTP_POST_VARS['belongsto']."','".$HTTP_POST_VARS['title']."', '0', '0', '2', '2', '2')");
						}
					}
				} else {
					// no user logged in
					if($dbtype == "pgsql") {
						$res = $db->query("INSERT INTO tree (belongs_to,title,owner,\"group\",userrights,grouprights,otherrights) VALUES ('".$HTTP_POST_VARS['belongsto']."','".$HTTP_POST_VARS['title']."', '0', '0', '2', '2', '2')");
					} else {
						$res = $db->query("INSERT INTO tree (belongs_to,title,owner,`group`,userrights,grouprights,otherrights) VALUES ('".$HTTP_POST_VARS['belongsto']."','".$HTTP_POST_VARS['title']."', '0', '0', '2', '2', '2')");
					}
				}	
			}
			
			
			
			$_SESSION['open'][$HTTP_POST_VARS['belongsto']] = 1;
		}
	}
	
	if($HTTP_POST_VARS['submit'] && $HTTP_POST_VARS['upload']) {
		if($knowledgeroot->getContentRights($HTTP_POST_VARS['contentid'],$_SESSION['userid']) == 2) {
			$uploaddir = "uploads/";
			if(move_uploaded_file($_FILES['datei']['tmp_name'], $uploaddir . $_FILES['datei']['name'])) {
		//
			$fp = fopen($uploaddir.$_FILES['datei']['name'],"r");
			$buffer = fread($fp,filesize($uploaddir.$_FILES['datei']['name']));
			fclose($fp);
		
			//import for postgresql
			if($dbtype == "pgsql") {
				$db->query ("begin");
				$oid = $db->lo_create ();
				$rs = $db->query("insert into files(belongs_to,object,filename,filesize,filetype,owner) values('".$HTTP_POST_VARS['contentid']."',$oid,'" . $_FILES['datei']['name'] .  "','" . $_FILES['datei']['size'] . "','" . $_FILES['datei']['type'] . "','".$_SESSION['userid']."');");//object field type must be "oid"
				$handle = $db->lo_open ($oid, "w");
				$db->lo_write ($handle, $buffer);
				$db->lo_close ($handle);
				$db->query ("commit");
			}
		
			//import for mysql
			if($dbtype == "mysql") {
				$db->query("INSERT INTO files(belongs_to,file,filename,filesize,filetype,owner) VALUES ('".$HTTP_POST_VARS['contentid']."','".addslashes(serialize($buffer))."','" . $_FILES['datei']['name'] .  "','" . $_FILES['datei']['size'] . "','" . $_FILES['datei']['type'] . "','".$_SESSION['userid']."')");
			}
		
			unlink($uploaddir.$_FILES['datei']['name']);
			
		//	
			}
		}
	}
	
	if($HTTP_GET_VARS['delid'] != "") {
		if($knowledgeroot->getContentRights($HTTP_GET_VARS['delid'],$_SESSION['userid']) == 2) {
			$res = $db->query("UPDATE content SET deleted=1 WHERE id='".$HTTP_GET_VARS['delid']."'");
			$res = $db->query("UPDATE files SET deleted=1 WHERE belongs_to='".$HTTP_GET_VARS['delid']."'");
			//$res = $db->query("DELETE FROM content WHERE id='".$HTTP_GET_VARS['delid']."'");
			//$res = $db->query("DELETE FROM files WHERE belongs_to='".$HTTP_GET_VARS['delid']."'");
		}
	}
	
	if($HTTP_GET_VARS['delpage'] != "" && $HTTP_GET_VARS['delpage'] != "1") {
		if($knowledgeroot->getPageRights($HTTP_GET_VARS['delpage'],$_SESSION['userid']) == 2) {
			$res = $db->query("SELECT count(*) AS anz FROM content WHERE belongs_to='".$HTTP_GET_VARS['delpage']."'");
			$row = $db->fetch_object($res);
			$anz = $row->anz;
			
			$res = $db->query("SELECT count(*) AS anz FROM tree WHERE belongs_to='".$HTTP_GET_VARS['delpage']."'");
			$row = $db->Fetch_object($res);
			$anz = $anz + $row->anz; 
			
			if($anz == "0") {
				//$res = $db->query("DELETE FROM tree WHERE id='".$HTTP_GET_VARS['delpage']."'");
				$res = $db->query("UPDATE tree SET deleted=1 WHERE id='".$HTTP_GET_VARS['delpage']."'");
			} else {
				$delpagemessage = "<div class=\"redmsg\">". $languagetoken[$language]['delpagefailed'] . "</div>\n";
			}
		}
	}
	
	if($HTTP_POST_VARS['editpage'] != "" && $HTTP_POST_VARS['editpage'] != "1") {
		if($knowledgeroot->getPageRights($_SESSION['cid'],$_SESSION['userid']) == 2 && $HTTP_POST_VARS['title'] != "") {
			if($_SESSION['rightedit'] == 1 || $_SESSION['admin'] == 1) {
				if($dbtype == "pgsql") {
					$res = $db->query("UPDATE tree SET title='".$HTTP_POST_VARS['title']."', owner='".$HTTP_POST_VARS['user']."', \"group\"='".$HTTP_POST_VARS['group']."', userrights='".$HTTP_POST_VARS['userrights']."', grouprights='".$HTTP_POST_VARS['grouprights']."', otherrights='".$HTTP_POST_VARS['otherrights']."' WHERE id='".$_SESSION['cid']."'");
				} else {
					$res = $db->query("UPDATE tree SET title='".$HTTP_POST_VARS['title']."', owner='".$HTTP_POST_VARS['user']."', `group`='".$HTTP_POST_VARS['group']."', userrights='".$HTTP_POST_VARS['userrights']."', grouprights='".$HTTP_POST_VARS['grouprights']."', otherrights='".$HTTP_POST_VARS['otherrights']."' WHERE id='".$_SESSION['cid']."'");
				}
				
				if($HTTP_POST_VARS['recursiv'] == 1) {
					$knowledgeroot->setRightsRecursiv($_SESSION['cid'],$_SESSION['userid'],$HTTP_POST_VARS['user'],$HTTP_POST_VARS['group'],$HTTP_POST_VARS['userrights'].$HTTP_POST_VARS['grouprights'].$HTTP_POST_VARS['otherrights']);
				}
			} else {
				$res = $db->query("UPDATE tree SET title='".$HTTP_POST_VARS['title']."' WHERE id='".$_SESSION['cid']."'");
			}
		}
	}
	
	if($HTTP_GET_VARS['delfile'] != "") {
		$res = $db->query("SELECT belongs_to FROM files WHERE id='".$HTTP_GET_VARS['delfile']."'");
		$anz = $db->num_rows($res);
		
		if($anz == 1) {
			$row = $db->fetch_assoc($res);
			
			if($knowledgeroot->getContentRights($row['belongs_to'],$_SESSION['userid']) == 2) {
			
				if($dbtype == "pgsql") {
					$res = $db->query("SELECT object FROM files WHERE id='".$HTTP_GET_VARS['delfile']."'");
			
					$anz = $db->num_rows($res);
			
					if($anz == 1) {
						$row = $db->fetch_assoc($res);
						$db->lo_unlink($row['object']);
					}
				}
				
				//$res = $db->query("DELETE FROM files WHERE id='".$HTTP_GET_VARS['delfile']."'");
				$res = $db->query("UPDATE files SET deleted=1 WHERE id='".$HTTP_GET_VARS['delfile']."'");
			}
		}
	}

	if($HTTP_POST_VARS['submit'] && $HTTP_POST_VARS['action'] == "createroot") {
		// rechte checken -> adminrechte
		if($_SESSION['admin'] == 1) {
			//fr mysql umschreiben wegen " um group
			if($dbtype == "pgsql") {
				$res = $db->query("INSERT INTO tree (belongs_to, title, owner, \"group\", userrights, grouprights, otherrights) VALUES (0, '".$HTTP_POST_VARS['title']."', '".$HTTP_POST_VARS['user']."', '".$HTTP_POST_VARS['group']."', '".$HTTP_POST_VARS['userrights']."', '".$HTTP_POST_VARS['grouprights']."', '".$HTTP_POST_VARS['otherrights']."')");
			} else {
				$res = $db->query("INSERT INTO tree (belongs_to, title, owner, `group`, userrights, grouprights, otherrights) VALUES (0, '".$HTTP_POST_VARS['title']."', '".$HTTP_POST_VARS['user']."', '".$HTTP_POST_VARS['group']."', '".$HTTP_POST_VARS['userrights']."', '".$HTTP_POST_VARS['grouprights']."', '".$HTTP_POST_VARS['otherrights']."')");
			}
		}
	}
	
	if($HTTP_POST_VARS['submit'] && $HTTP_POST_VARS['action'] == "adduser" && $HTTP_POST_VARS['name'] != "") {
		if($_SESSION['admin'] == 1) {
			//print_r($HTTP_POST_VARS['groups']);
			$res = $db->query("INSERT INTO users (name, password, enabled, defaultgroup, defaultrights, admin, rightedit) VALUES ('".$HTTP_POST_VARS['name']."','".md5($HTTP_POST_VARS['password'])."', ".$HTTP_POST_VARS['enabled'].", ".$HTTP_POST_VARS['defaultgroup'].", ".$HTTP_POST_VARS['userrights'].$HTTP_POST_VARS['grouprights'].$HTTP_POST_VARS['otherrights'].",".$HTTP_POST_VARS['admin'].",".$HTTP_POST_VARS['rightedit'].")");
			
			$res = $db->query("SELECT id FROM users WHERE name='".$HTTP_POST_VARS['name']."'");
			while($row = $db->fetch_assoc($res)) {
				foreach($HTTP_POST_VARS['groups'] as $key => $value) {
					$res = $db->query("INSERT INTO user_group (userid, groupid) VALUES (".$row['id'].",".$value.")");
				}
			}
		
			$HTTP_GET_VARS['action'] = "users";
		}	
	}
	
	if($HTTP_POST_VARS['submit'] && $HTTP_POST_VARS['action'] == "edituser" && $HTTP_POST_VARS['name'] != "") {
		if($_SESSION['admin'] == 1) {
			//print_r($HTTP_POST_VARS['groups']);
			if($HTTP_POST_VARS['password'] == "") {
				$res = $db->query("UPDATE users SET name='".$HTTP_POST_VARS['name']."', enabled=".$HTTP_POST_VARS['enabled'].", defaultgroup=".$HTTP_POST_VARS['defaultgroup'].", defaultrights=".$HTTP_POST_VARS['userrights'].$HTTP_POST_VARS['grouprights'].$HTTP_POST_VARS['otherrights'].", admin=".$HTTP_POST_VARS['admin'].", rightedit=".$HTTP_POST_VARS['rightedit']." WHERE id=".$HTTP_POST_VARS['uid']."");
			} else {
				$res = $db->query("UPDATE users SET name='".$HTTP_POST_VARS['name']."', password='".md5($HTTP_POST_VARS['password'])."', enabled=".$HTTP_POST_VARS['enabled'].", defaultgroup=".$HTTP_POST_VARS['defaultgroup'].", defaultrights=".$HTTP_POST_VARS['userrights'].$HTTP_POST_VARS['grouprights'].$HTTP_POST_VARS['otherrights'].", admin=".$HTTP_POST_VARS['admin'].", rightedit=".$HTTP_POST_VARS['rightedit']." WHERE id=".$HTTP_POST_VARS['uid']."");
			}
			
			$res = $db->query("DELETE FROM user_group WHERE userid=".$HTTP_POST_VARS['uid']."");
			foreach($HTTP_POST_VARS['groups'] as $key => $value) {
				$res = $db->query("INSERT INTO user_group (userid, groupid) VALUES (".$HTTP_POST_VARS['uid'].",".$value.")");
			}
			
			$HTTP_GET_VARS['action'] = "users";
		}
	}
	
	if($HTTP_POST_VARS['submit'] && $HTTP_POST_VARS['action'] == "addgroup" && $HTTP_POST_VARS['name'] != "") {
		if($_SESSION['admin'] == 1) {
			$res = $db->query("INSERT INTO groups (name,enabled) VALUES ('".$HTTP_POST_VARS['name']."', 1)");
			$HTTP_GET_VARS['action'] = "users";
		}
	}
	
	if($HTTP_POST_VARS['submit'] && $HTTP_POST_VARS['action'] == "editgroup" && $HTTP_POST_VARS['name'] != "") {
		if($_SESSION['admin'] == 1) {
			$res = $db->query("UPDATE groups SET name='".$HTTP_POST_VARS['name']."' WHERE id=".$HTTP_POST_VARS['gid']."");
			$HTTP_GET_VARS['action'] = "users";
		}
	}
	
	if($HTTP_GET_VARS['action'] == "deluser" && $HTTP_GET_VARS['uid'] != "") {
		if($_SESSION['admin'] == 1) {
			$res = $db->query("DELETE FROM users WHERE id =".$HTTP_GET_VARS['uid']."");
			$HTTP_GET_VARS['action'] = "users";
		}
	}

	if($HTTP_GET_VARS['action'] == "delgroup" && $HTTP_GET_VARS['gid'] != "") {
		if($_SESSION['admin'] == 1) {
			$res = $db->query("DELETE FROM groups WHERE id =".$HTTP_GET_VARS['gid']."");
			$HTTP_GET_VARS['action'] = "users";
		}
	}

	if($HTTP_POST_VARS['action'] == "options") {
		if($HTTP_POST_VARS['password'] == $HTTP_POST_VARS['password1'] && $_SESSION['userid'] != 0) {
			$res = $db->query("UPDATE users SET password='".md5($HTTP_POST_VARS['password'])."' WHERE id=".$_SESSION['userid']."");
			$message = "<div class=\"greenmsg\">".$languagetoken[$language]['optionform']['changed']."</div>";
		} else {
			$message = "<div class=\"redmsg\">".$languagetoken[$language]['optionform']['failed']."</div>";
		}
	}
	
}

$tree = new categoryTree();
$tree->start($db,$doexpand,$_SESSION['userid'],$_SESSION['groupid']);

if($readonly == 0) {

	// move page
	if($HTTP_POST_VARS['move'] == "move" && $HTTP_POST_VARS['to'] != $_SESSION['cid']) {
		if($knowledgeroot->getPageRights($_SESSION['cid'],$_SESSION['userid']) == 2 && $knowledgeroot->getPageRights($HTTP_POST_VARS['to'],$_SESSION['userid']) == 2) {
			
			// check if element is a kind of element to move -> if yes than abort
			if(!$tree->isParentelement($HTTP_POST_VARS['to'],$_SESSION['cid'])) {
				$res = $db->query("UPDATE tree SET belongs_to='".$HTTP_POST_VARS['to']."' WHERE id='".$_SESSION['cid']."'");
			}
		}
	}
	
	// move page content
	if($HTTP_POST_VARS['move'] == "cmove" && $HTTP_POST_VARS['to'] != $_SESSION['cid'] && $HTTP_POST_VARS['contentid'] != "") {
		if($knowledgeroot->getPageRights($HTTP_POST_VARS['to'],$_SESSION['userid']) == 2 && $knowledgeroot->getContentRights($HTTP_POST_VARS['contentid'],$_SESSION['userid']) == 2) {
			$res = $db->query("UPDATE content SET belongs_to='".$HTTP_POST_VARS['to']."' WHERE id='".$HTTP_POST_VARS['contentid']."'");
		}
	}
	
	
	if($HTTP_GET_VARS['openid'] != "") {
		//echo "#$#".$_SESSION['open'][$openid]."#";
		if($_SESSION['open'][$HTTP_GET_VARS['openid']] == 0) {
			$_SESSION['open'][$HTTP_GET_VARS['openid']] = 1;
			//echo ":::";
		} else {
			$_SESSION['open'][$HTTP_GET_VARS['openid']] = 0;
		}
		
		// save treecache
		if(!empty($_SESSION['userid'])) {
			$res = $db->query("UPDATE users SET treecache='".serialize($_SESSION['open'])."' WHERE id=".$_SESSION['userid']."");
		}
	}

}
?>
<html>
<head>
	<title>KnowledgeRoot</title>
<?php
if($charset != "") {
	echo "\t<meta http-equiv=\"Content-Type\" content=\"text/html\" charset=\"" . $charset . "\">\n";
}
?>
	<link rel="stylesheet" href="knowledgeroot.css" type="text/css">
</head>
<body>
<a name="top"></a>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr class="head"><td class="head" colspan="2"><table border="0" cellpadding="0" cellspacing="0" width="100%"><tr><td><div class="title"><?php echo $title; ?></div></td><td align="right" valign="bottom"><div class="version"><a href="http://www.linuxdelta.de/KnowledgeRoot.144.0.html">Knowledgeroot</a> - Frank Habermann - <?php echo $languagetoken[$language]['version'] . ":&nbsp;" . $version; ?></div>
<div class="mainnavi">[<?php
if($_SESSION['user'] == "guest" || empty($_SESSION['userid'])) {
	echo "<a href=\"index.php?action=login\">".$languagetoken[$language]['menu']['login']."</a>"; 
} else {
	if($_SESSION['admin'] == 1) {
		echo "<a href=\"index.php?action=createroot\">".$languagetoken[$language]['menu']['roots']."</a>]&nbsp;";
		echo "[<a href=\"index.php?action=users\">".$languagetoken[$language]['menu']['user']."</a>]&nbsp;";
		echo "[<a href=\"index.php?action=options\">".$languagetoken[$language]['menu']['options']."</a>]&nbsp;";
		echo "[<a href=\"index.php?action=logout\">".$languagetoken[$language]['menu']['logout']."</a>"; 
	} else {
		echo "<a class=\"mainnavi\" href=\"index.php?action=options\">".$languagetoken[$language]['menu']['options']."</a>]&nbsp;";
 		echo "[<a class=\"mainnavi\" href=\"index.php?action=logout\">".$languagetoken[$language]['menu']['logout']."</a>"; 	
	}
} ?>
]</div></td></tr></table></td></tr>

<tr class="navigationpath"><form action="index.php" method="post"><td class="navigation" colspan="2"><div class="navigationleft"><b><?php echo $languagetoken[$language]['path']; ?>:
<?php

$path = new pathTree();
$path->start($db,$doexpand,$_SESSION['userid'],$_SESSION['groupid']);

if($knowledgeroot->checkRecursivPerm($_SESSION['cid'], $_SESSION['userid']) != 0) {
	echo $path->getPath($_SESSION['cid']);
} else {
	echo "/";
}

?>

</b></div><div class="navigationright"><?php echo $languagetoken[$language]['user'] . ":&nbsp;" . $_SESSION['user']; ?>&nbsp;</div>
<div class="navigationmiddle">
	
		<?php echo $languagetoken[$language]['search']; ?>:
		<input class="searchfield" type="text" name="search" value="">
		<input class="searchgo" type="submit" name="submit" value="<?php echo $languagetoken[$language]['searchgo']; ?>">
	
</div></td></form></tr>

<tr>
 <td align="left" style="padding:10px 10px 5px 15px;" valign="top" width="100">
<?php
$tree->open = $_SESSION['open'];

$tree->buildTree(0);

?>
 </td>
 <td align="left" valign="top" style="padding:20px 20px 20px 20px;">
<?php

	if($HTTP_GET_VARS['action'] == "newcontent" && $readonly == 0) {
		if($knowledgeroot->getPageRights($_SESSION['cid'],$_SESSION['userid']) == 2) {
			echo "[<a href=\"index.php\">".$languagetoken[$language]['back']."</a>]<br><br>";
			echo "<form action=\"index.php\" method=\"post\">";
			echo "<input type=\"hidden\" name=\"neditid\" value=\"new\">";
			echo "<input type=\"hidden\" name=\"belongsto\" value=\"".$_SESSION['cid']."\">";
			echo "<input type=\"hidden\" name=\"submit\" value=\"submit\">";
			echo "<input type=\"submit\" name=\"save\" value=\"".$languagetoken[$language]['save']."\">";
			echo "<input type=\"submit\" name=\"saveandclose\" value=\"".$languagetoken[$language]['saveandclose']."\">";
			echo "<input type=\"submit\" name=\"close\" value=\"".$languagetoken[$language]['close']."\">";
			echo "<br><br>\n";
					
			if($htmleditor == 1) {
				$sBasePath = $_SERVER['PHP_SELF'] ;
				$sBasePath = substr( $sBasePath, 0, strpos( $sBasePath, "index.php" ) );
				
				$oFCKeditor = new FCKeditor('content') ;
				$oFCKeditor->BasePath	= $sBasePath;
				$oFCKeditor->Value = '' ;
				$oFCKeditor->Width  = $htmleditorwidth;
				$oFCKeditor->Height = $htmleditorheight;
				$oFCKeditor->Config['AutoDetectLanguage']	= $htmleditorlangdetect;
				$oFCKeditor->Config['DefaultLanguage']		= $htmleditorlangdefault;
				$oFCKeditor->Config['SkinPath'] = $sBasePath . 'editor/skins/' . $htmleditorskin . '/' ;
				$oFCKeditor->ToolbarSet = $htmleditortoolbar;
				$oFCKeditor->Create() ;
			} else {
				echo "<textarea name=\"content\" cols=\"75\" rows=\"20\">\n";
				echo "</textarea>\n";
			}
			
			echo "<br><br>\n";
			//check rights!!!
			
			if(!empty($_SESSION['userid'])) {
				echo $knowledgeroot->rightpanel($_SESSION['userid']);
			}
			
			echo "<br><br>\n";
			echo "<input type=\"submit\" name=\"submit\" value=\"".$languagetoken[$language]['save']."\">";
			echo "<input type=\"submit\" name=\"submit\" value=\"".$languagetoken[$language]['saveandclose']."\">";
			echo "<input type=\"submit\" name=\"submit\" value=\"".$languagetoken[$language]['close']."\">";
			echo "</form>";
		}
	} elseif($HTTP_GET_VARS['action'] == "newpage" && $readonly == 0) {
		if($knowledgeroot->getPageRights($_SESSION['cid'],$_SESSION['userid']) == 2) {
			echo "[<a href=\"index.php\">".$languagetoken[$language]['back']."</a>]<br><br>";
			echo "<form action=\"index.php\" method=\"post\">";
			echo "<input type=\"hidden\" name=\"newpage\" value=\"new\">";
			echo "<input type=\"hidden\" name=\"belongsto\" value=\"".$_SESSION['cid']."\">";
			echo "<input type=\"text\" name=\"title\" value=\"\"><br>";
			echo "<input type=\"submit\" name=\"submit\" value=\"".$languagetoken[$language]['save']."\">";
			//check rights!!!
			if(!empty($_SESSION['userid'])) {
				echo $knowledgeroot->rightpanel($_SESSION['userid']);
			}
			
			echo "</form>";
		}
	} elseif($HTTP_GET_VARS['action'] == "editpage" && $readonly == 0) {
		if($knowledgeroot->getPageRights($_SESSION['cid'],$_SESSION['userid']) == 2) {
			$res = $db->query("SELECT * FROM tree WHERE id='".$_SESSION['cid']."'");
			$anz = $db->num_rows($res);
	
			if($anz == 1) {
				$row = $db->fetch_assoc($res);
			}
			
			echo "[<a href=\"index.php\">".$languagetoken[$language]['back']."</a>]<br><br>";
			echo "<form action=\"index.php\" method=\"post\">";
			echo "<input type=\"hidden\" name=\"editpage\" value=\"".$_SESSION['cid']."\">";
			echo "<input type=\"text\" name=\"title\" value=\"".$row['title']."\"><br>";
			echo "<input type=\"submit\" name=\"submit\" value=\"".$languagetoken[$language]['rename']."\">";
			
			//check rights
			if(!empty($_SESSION['userid'])) {
				echo $knowledgeroot->editRightPanel($row['owner'],$row['group'],$row['userrights'].$row['grouprights'].$row['otherrights'],1);
			}
			
			echo "</form>";
		}
	} elseif($HTTP_GET_VARS['eid'] != "" && $readonly == 0) {
		if($knowledgeroot->getPageRights($_SESSION['cid'],$_SESSION['userid']) == 2 && $knowledgeroot->getContentRights($HTTP_GET_VARS['eid'],$_SESSION['userid']) == 2) {
			echo "[<a href=\"index.php\">".$languagetoken[$language]['back']."</a>]<br><br>";
			echo "<form action=\"index.php\" method=\"post\">";
			echo "<input type=\"hidden\" name=\"editid\" value=\"".$HTTP_GET_VARS['eid']."\">";
			echo "<input type=\"hidden\" name=\"submit\" value=\"submit\">";
			echo "<input type=\"submit\" name=\"save\" value=\"".$languagetoken[$language]['save']."\">";
			echo "<input type=\"submit\" name=\"saveandclose\" value=\"".$languagetoken[$language]['saveandclose']."\">";
			echo "<input type=\"submit\" name=\"close\" value=\"".$languagetoken[$language]['close']."\">";
			echo "<br><br>\n";
			$res = $db->query("SELECT * FROM content WHERE id='".$HTTP_GET_VARS['eid']."' ORDER BY id ASC");
	
			while($row = $db->fetch_assoc($res)) {
				if($htmleditor == 1) {
					$sBasePath = $_SERVER['PHP_SELF'] ;
					$sBasePath = substr( $sBasePath, 0, strpos( $sBasePath, "index.php" ) );
					
					$oFCKeditor = new FCKeditor('content') ;
					$oFCKeditor->BasePath	= $sBasePath;
					$oFCKeditor->Value = $row['content'];
					$oFCKeditor->Width  = $htmleditorwidth;
					$oFCKeditor->Height = $htmleditorheight;
					$oFCKeditor->Config['AutoDetectLanguage']	= $htmleditorlangdetect;
					$oFCKeditor->Config['DefaultLanguage']		= $htmleditorlangdefault;
					$oFCKeditor->ToolbarSet = $htmleditortoolbar;
					$oFCKeditor->Config['SkinPath'] = $sBasePath . 'editor/skins/' . $htmleditorskin . '/' ;
					$oFCKeditor->Create() ;
				} else {
					echo "<textarea name=\"content\" cols=\"75\" rows=\"20\">\n";
					echo $row['content'];
					echo "</textarea>\n";
				}
				
				echo "<br><br>";
				
				//check rights		
				if(!empty($_SESSION['userid'])) {
					echo $knowledgeroot->editRightPanel($row['owner'],$row['group'],$row['userrights'].$row['grouprights'].$row['otherrights']);
				}
			}
			
			echo "<br><br>";
			echo "<input type=\"submit\" name=\"submit\" value=\"".$languagetoken[$language]['save']."\">";
			echo "<input type=\"submit\" name=\"submit\" value=\"".$languagetoken[$language]['saveandclose']."\">";
			echo "<input type=\"submit\" name=\"submit\" value=\"".$languagetoken[$language]['close']."\">";
			echo "</form>";
		}
	} elseif ($HTTP_POST_VARS['submit'] && $HTTP_POST_VARS['search'] != "") {
		$searchword = addslashes($HTTP_POST_VARS['search']);
		echo $languagetoken[$language]['searchfor'] . " <b>'" . $searchword . "'</b><br><br>";
		
		echo "<h3>" . $languagetoken[$language]['searchcontent'] . ":</h3>\n";
		
		$_SESSION['userid'] = $_SESSION['userid'] == "" ? 0 : $_SESSION['userid'];
		$_SESSION['groupid'] = $_SESSION['userid'] == "" ? 0 : $_SESSION['groupid'];
		
		if($_SESSION['admin'] == 1) {
			if($dbtype == "pgsql") {
				$sql = "SELECT id,belongs_to,content FROM content WHERE content ilike '%$searchword%' AND deleted=0";
			} else {
				$sql = "SELECT id,belongs_to,content FROM content WHERE content like '%$searchword%' AND deleted=0";
			}
		} else {
			if($dbtype == "pgsql") {
				$sql = "SELECT id,belongs_to,content FROM content WHERE content ilike '%$searchword%' AND deleted=0 AND ((otherrights > 0) OR (\"group\"='".$_SESSION['groupid']."' AND grouprights > 0) OR (owner='".$_SESSION['userid']."' AND userrights>0))";
			} else {
				$sql = "SELECT id,belongs_to,content FROM content WHERE content like '%$searchword%' AND deleted=0 AND ((otherrights > 0) OR (\"group\"='".$_SESSION['groupid']."' AND grouprights > 0) OR (owner='".$_SESSION['userid']."' AND userrights>0))";
			}
		}
		
		$res = $db->query($sql);
		$anz = $db->num_rows($res);
		
		if($anz != 0) {
			$x = 0;
			while($row = $db->fetch_assoc($res)) {
				//echo $row['id'];
				if($knowledgeroot->checkRecursivPerm($row['belongs_to'],$_SESSION['userid']) != 0) {
					echo $path->getPath($row['belongs_to']) . "&nbsp;/&nbsp;[<a href=\"index.php?id=" . $row['belongs_to'] . "#" . $row['id'] . "\">" . $languagetoken[$language]['searchshow'] . "</a>]<br>\n";
					$x++;
				}
			}
			
			if($x == 0) {
				echo $languagetoken[$language]['nothingfound'] . "<br>\n";
			}
		} else {
			echo $languagetoken[$language]['nothingfound'];
		}
		
		echo "<hr>\n";
		
		echo "<h3>" . $languagetoken[$language]['searchmenu'] . ":</h3>\n";
		
		if($dbtype == "pgsql") {
			$sql = "SELECT id,belongs_to,title FROM tree WHERE title ilike '%$searchword%'";
		} else {
			$sql = "SELECT id,belongs_to,title FROM tree WHERE title like '%$searchword%'";
		}
		
		$res = $db->query($sql);
		$anz = $db->num_rows($res);
		
		if($anz != 0) {
			$x = 0;
			while($row = $db->fetch_assoc($res)) {
				//echo $row['id'];
				if($knowledgeroot->checkRecursivPerm($row['id'], $_SESSION['userid']) != 0) {
					echo $path->getPath($row['id']) . "<br>\n";
					$x++;
				}
			}
			
			if($x == 0) {
				echo $languagetoken[$language]['nothingfound'] . "<br>\n";
			}
		} else {
			echo $languagetoken[$language]['nothingfound'] . "<br>\n";
		}

		echo "<hr>\n";
		
		echo "<h3>" . $languagetoken[$language]['searchfiles'] . ":</h3>\n";
		
		if($dbtype == "pgsql") {
			$sql = "SELECT f.id,t.belongs_to,f.filename,f.filesize FROM files f, tree t, content c WHERE f.belongs_to = c.id AND c.belongs_to = t.id AND filename ilike '%$searchword%'";
		} else {
			$sql = "SELECT f.id,t.belongs_to,f.filename,f.filesize FROM files f, tree t, content c WHERE f.belongs_to = c.id AND c.belongs_to = t.id AND filename like '%$searchword%'";
		}
		
		$res = $db->query($sql);
		$anz = $db->num_rows($res);
		
		if($anz != 0) {
			$x = 0;
			while($row = $db->fetch_assoc($res)) {
				//echo $row['id'];
				if($knowledgeroot->checkRecursivPerm($row['belongs_to'], $_SESSION['userid']) != 0) {
					echo $path->getPath($row['belongs_to']) . "&nbsp;/\n";
					echo "<a href=\"index.php?download=".$row['id']."\"><img border=\"0\" src=\"images/file.gif\">".$row['filename']."</a>&nbsp;<font class=\"text\">[".getfilesize($row['filesize'])."]</font><br>\n";
					$x++;
				}
			}
			
			if($x == 0) {
				echo $languagetoken[$language]['nothingfound'] . "<br>\n";
			}
		} else {
			echo $languagetoken[$language]['nothingfound'] . "<br>\n";
		}
	} elseif($HTTP_GET_VARS['action'] == "login") {
		echo '
			<div class="loginform">
			
			<fieldset>
    				<legend><b>'.$languagetoken[$language]['loginform']['title'].'</b></legend>
				
			<form action="index.php" method="post">
			<input type="hidden" name="'.session_name().'" value="'.session_id().'">
			<table class="loginform" border="0" cellspacing="0" cellpadding="0" width="300">
				<tr><td><b style="color:#FFFFFF">Login</b></td></tr>
				<tr><td>'.$languagetoken[$language]['loginform']['user'].':</td><td align="right" style="padding:2px 2px 2px 2px;"><input type="text" name="user" value="" size="20"></td></tr>
				<tr><td>'.$languagetoken[$language]['loginform']['password'].':</td><td align="right" style="padding:2px 2px 2px 2px;"><input type="password" name="password" value="" size="20"></td></tr>
				<tr><td colspan="2" align="right" style="padding:2px 2px 2px 2px;"><input type="submit" name="login" value="'.$languagetoken[$language]['loginform']['submit'].'"></td></tr>
			</table>
			</form>
			
			</fieldset>
			</div>
		';
	} elseif($HTTP_GET_VARS['action'] == "createroot" && $_SESSION['admin']) {
		// rechte checken -> adminrechte
		echo '
			<h2>'.$languagetoken[$language]['rootform']['title'].'</h2>
			<div class="createroot">
			<form action="index.php" method="post">
			<input type="hidden" name="action" value="createroot">
			<input type="hidden" name="'.session_name().'" value="'.session_id().'">
			
			<fieldset>
    				<legend><b>'.$languagetoken[$language]['rootform']['title'].'</b></legend>
				
			<table border="0" cellspacing="1" cellpadding="1" width="300">
				<tr><td>'.$languagetoken[$language]['rootform']['name'].':</td><td style="padding:2px 2px 2px 2px;" colspan="3"><input type="text" name="title" value="" size="20"></td></tr>
				<tr><td></td><td><input type="submit" name="submit" value="'.$languagetoken[$language]['rootform']['submit'].'"></td></tr>
			</table><p />';
			
		if(!empty($_SESSION['userid'])) {
			echo $knowledgeroot->rightpanel($_SESSION['userid']);	
		}	
			
			
		echo '	</fiedliest></form>
			</div>
		';
	} elseif(($HTTP_GET_VARS['action'] == "options" || $HTTP_POST_VARS['action'] == "options") && !empty($_SESSION['userid'])) {
		echo '
			<h2>'.$languagetoken[$language]['optionform']['title'].'</h2>
			';
		
		echo $message . "<br>\n";
			
		echo '	
			<fieldset>
    				<legend><b>'.$languagetoken[$language]['optionform']['subtitle'].'</b></legend>
				
			<form action="index.php" method="post">
			<input type="hidden" name="action" value="options">
			<table border="0" cellpadding="0" cellspacing="0" width="300">
				<tr><td>'.$languagetoken[$language]['optionform']['newpassword'].':</td><td align="right" style="padding:2px 2px 2px 2px;"><input type="password" name="password" value=""></td></tr>
				<tr><td>'.$languagetoken[$language]['optionform']['newpassword2'].':</td><td align="right" style="padding:2px 2px 2px 2px;"><input type="password" name="password1" value=""></td></tr>
				<tr><td align="right" colspan="2" style="padding:2px 2px 2px 2px;"><input type="submit" name="submit" value="'.$languagetoken[$language]['optionform']['submit'].'"></td></tr>
			</table>
			</form>
			
			</fieldset>
		';
	} elseif($HTTP_GET_VARS['action'] == "users" && $_SESSION['admin'] == 1) {
		// list users
		echo '
			<h2>'.$languagetoken[$language]['userform']['usertitle'].'</h2>
			[<a href="index.php?action=adduser">'.$languagetoken[$language]['userform']['adduser'].'</a>]<br>
			<table style="border:1px solid #000000;" cellpadding="1" cellspacing="1">
				<tr><td>'.$languagetoken[$language]['userform']['username'].'</td><td>'.$languagetoken[$language]['userform']['defaultgroup'].'</td><td>'.$languagetoken[$language]['userform']['defaultrights'].'</td><td>'.$languagetoken[$language]['userform']['admin'].'</td><td>'.$languagetoken[$language]['userform']['rightedit'].'</td><td>'.$languagetoken[$language]['userform']['enabled'].'</td><td>'.$languagetoken[$language]['userform']['action'].'</td></tr>
		';
		
		$res = $db->query("SELECT * FROM users");
		while($row = $db->fetch_assoc($res)) {
			echo "<tr><td>".$row['name']."</td><td>".$knowledgeroot->getGroup($row['defaultgroup'])."</td><td>".$row['defaultrights']."</td><td>".$knowledgeroot->yesno($row['admin'])."</td><td>".$knowledgeroot->yesno($row['rightedit'])."</td><td>".$knowledgeroot->yesno($row['enabled'])."</td><td>[<a href=\"index.php?action=edituser&amp;uid=".$row['id']."\">".$languagetoken[$language]['userform']['edit']."</a>]&nbsp;[<a href=\"index.php?action=deluser&amp;uid=".$row['id']."\" onclick=\"return confirm('" . $languagetoken[$language]['userform']['deluserask'] . "');\">".$languagetoken[$language]['userform']['delete']."</a>]</td></tr>\n";
		}
		
		echo '
			</table>
		';
		
		// list groups
		echo '
			<h2>'.$languagetoken[$language]['userform']['grouptitle'].'</h2>
			[<a href="index.php?action=addgroup">'.$languagetoken[$language]['userform']['addgroup'].'</a>]<br>
			<table style="border:1px solid #000000;" cellpadding="1" cellspacing="1">
				<tr><td>'.$languagetoken[$language]['userform']['groupname'].'</td><td>'.$languagetoken[$language]['userform']['action'].'</td></tr>
		';
		
		$res = $db->query("SELECT * FROM groups");
		while($row = $db->fetch_assoc($res)) {
			echo "<tr><td>".$row['name']."</td><td>[<a href=\"index.php?action=editgroup&amp;gid=".$row['id']."\">".$languagetoken[$language]['userform']['edit']."</a>]&nbsp;[<a href=\"index.php?action=delgroup&amp;gid=".$row['id']."\" onclick=\"return confirm('" . $languagetoken[$language]['userform']['delgroupask'] . "');\">".$languagetoken[$language]['userform']['delete']."</a>]</td></tr>\n";
		}
		
		echo '
			</table>
		';
	} elseif($HTTP_GET_VARS['action'] == "adduser" && $_SESSION['admin'] == 1) {
		echo '
			<h2>'.$languagetoken[$language]['userform']['adduser'].'</h2>
			
			<form action="index.php" method="post">
			<input type="hidden" name="action" value="adduser">
			
			<fieldset>
    				<legend><b>'.$languagetoken[$language]['userform']['newuser'].'</b></legend>
			<table border="0" cellpadding="1" cellspacing="3">
			<tr><td>'.$languagetoken[$language]['userform']['username'].': </td><td><input type="text" name="name" value=""></td></tr>
			<tr><td>'.$languagetoken[$language]['userform']['password'].': </td><td><input type="password" name="password" value=""></td></tr>
			<tr><td>'.$languagetoken[$language]['userform']['defaultgroup'].': </td><td>' . $knowledgeroot->groupdropdown("defaultgroup") . '</td></tr>
			<tr><td>'.$languagetoken[$language]['userform']['admin'].': </td><td>' . $knowledgeroot->yesnodropdown("admin") . '</td></tr>
			<tr><td>'.$languagetoken[$language]['userform']['rightedit'].': </td><td>' . $knowledgeroot->yesnodropdown("rightedit") . '</td></tr>
			<tr><td>'.$languagetoken[$language]['userform']['enabled'].': </td><td>' . $knowledgeroot->yesnodropdown("enabled") . '</td></tr>
			<tr><td valign="top">'.$languagetoken[$language]['userform']['groups'].': </td><td> ' . $knowledgeroot->groupDropDown("groups[]","","yes") . ' </td></tr>
			<tr><td>'.$languagetoken[$language]['userform']['defaultrights'].': </td><td></td></tr>
			<tr><td>&nbsp;'.$languagetoken[$language]['userform']['user'].': </td><td><select name="userrights">'."\t<option value=\"2\" selected>Lesen+Schreiben</option>\n\t<option value=\"1\">Lesen</option>\n\t<option value=\"0\">Keine</option>\n".'</select></td></tr>
			<tr><td>&nbsp;'.$languagetoken[$language]['userform']['group'].': </td><td><select name="grouprights">'."\t<option value=\"2\">Lesen+Schreiben</option>\n\t<option value=\"1\" selected>Lesen</option>\n\t<option value=\"0\">Keine</option>\n".'</select></td></tr>
			<tr><td>&nbsp;'.$languagetoken[$language]['userform']['others'].': </td><td><select name="otherrights">'."\t<option value=\"2\">Lesen+Schreiben</option>\n\t<option value=\"1\" selected>Lesen</option>\n\t<option value=\"0\">Keine</option>\n".'</select></td></tr>
		
			<tr><td></td><td align="left"><input type="submit" name="submit" value="'.$languagetoken[$language]['userform']['submit'].'"></td></tr>
			</table>
			  </fieldset>
			</form>
		
		';
	} elseif($HTTP_GET_VARS['action'] == "edituser" && $_SESSION['admin'] == 1) {
		$res = $db->query("SELECT * FROM users WHERE id=".$HTTP_GET_VARS['uid']."");
		$anz = $db->num_rows($res);
		
		if($anz == 1) {
			$row = $db->fetch_assoc($res);
		
			//fetch groups
			$res = $db->query("SELECT * FROM user_group WHERE userid=".$row['id']."");
			$x = 0;
			while($rowgroup = $db->fetch_assoc($res)) {
				$grouparr[$x] = $rowgroup['groupid'];
				$x++;
			}
			
			echo '
				<h2>'.$languagetoken[$language]['userform']['edituser'].'</h2>
				
				<form action="index.php" method="post">
				<input type="hidden" name="action" value="edituser">
				<input type="hidden" name="uid" value="'.$row['id'].'">
				
				<fieldset>
					<legend><b>'.$languagetoken[$language]['userform']['edituser'].'</b></legend>
				
				<table border="0" cellpadding="1" cellspacing="3">
				<tr><td>'.$languagetoken[$language]['userform']['username'].': </td><td><input type="text" name="name" value="'.$row['name'].'"></td></tr>
				<tr><td>'.$languagetoken[$language]['userform']['password'].': </td><td><input type="password" name="password" value=""></td></tr>
				<tr><td>'.$languagetoken[$language]['userform']['defaultgroup'].': </td><td>' . $knowledgeroot->groupdropdown("defaultgroup",$row['defaultgroup']) . '</td></tr>
				<tr><td>'.$languagetoken[$language]['userform']['admin'].': </td><td>' . $knowledgeroot->yesnodropdown("admin", $row['admin']) . '</td></tr>
				<tr><td>'.$languagetoken[$language]['userform']['rightedit'].': </td><td>' . $knowledgeroot->yesnodropdown("rightedit",$row['rightedit']) . '</td></tr>
				<tr><td>'.$languagetoken[$language]['userform']['enabled'].': </td><td>' . $knowledgeroot->yesnodropdown("enabled",$row['enabled']) . '</td></tr>
				<tr><td valign="top">'.$languagetoken[$language]['userform']['groups'].': </td><td>' . $knowledgeroot->groupDropDown("groups[]","","yes",$grouparr) . ' </td></tr>
				<tr><td>'.$languagetoken[$language]['userform']['defaultrights'].': </td><td></td></tr>
				<tr><td>&nbsp; '.$languagetoken[$language]['userform']['user'].': </td><td>'.$knowledgeroot->rightDropDown("userrights",substr($row['defaultrights'],0,1)).'</td></tr>
				<tr><td>&nbsp; '.$languagetoken[$language]['userform']['group'].': </td><td>'.$knowledgeroot->rightDropDown("grouprights",substr($row['defaultrights'],1,1)).'</td></tr>
				<tr><td>&nbsp; '.$languagetoken[$language]['userform']['others'].': </td><td>'.$knowledgeroot->rightDropDown("otherrights",substr($row['defaultrights'],2,1)).'</td></tr>
			
				<tr><td></td><td><input type="submit" name="submit" value="'.$languagetoken[$language]['userform']['submit'].'"></td></tr>
				
				</table>
				</fieldset>
				</form>	
			';	
		}
	} elseif($HTTP_GET_VARS['action'] == "addgroup" && $_SESSION['admin'] == 1) {
		echo '
			<h2>'.$languagetoken[$language]['userform']['addgroup'].'</h2>
			<fieldset>
				<legend><b>'.$languagetoken[$language]['userform']['addgroup'].'</b></legend>
			<form action="index.php" method="post">
				<input type="hidden" name="action" value="addgroup">
				<table border="0" cellpadding="1" cellspacing="3">
				<tr><td>'.$languagetoken[$language]['userform']['groupname'].': </td><td><input type="text" name="name" value=""></td></tr>
				<tr><td></td><td><input type="submit" name="submit" value="'.$languagetoken[$language]['userform']['submit'].'"></td></tr>
				</table>
			</form>
		';
		
	} elseif($HTTP_GET_VARS['action'] == "editgroup" && $_SESSION['admin'] == 1) {
		$res = $db->query("SELECT * FROM groups WHERE id=".$HTTP_GET_VARS['gid']."");
		$anz = $db->num_rows($res);
		
		if($anz == 1) {
			$row = $db->fetch_assoc($res);
			echo '
				<h2>'.$languagetoken[$language]['userform']['editgroup'].'</h2>
				<fieldset>
					<legend><b>'.$languagetoken[$language]['userform']['editgroup'].'</b></legend>
				<form action="index.php" method="post">
					<input type="hidden" name="action" value="editgroup">
					<input type="hidden" name="gid" value="'.$row['id'].'">
					<table border="0" cellpadding="1" cellspacing="3">
					<tr><td>'.$languagetoken[$language]['userform']['groupname'].': </td><td><input type="text" name="name" value="'.$row['name'].'"></td></tr>
					<tr><td></td><td><input type="submit" name="submit" value="'.$languagetoken[$language]['userform']['submit'].'"></td></tr>
					</table>
				</form>
			';
		}
	
	} elseif($HTTP_GET_VARS['action'] == "error") {
		echo '
			HIER KOMMT DIE FEHLERMELDUNG
		';
	} else {

		if($_SESSION['cid'] != "" && $path->isTree($_SESSION['cid']) && $knowledgeroot->checkRecursivPerm($_SESSION['cid'], $_SESSION['userid']) != 0) {
			echo $delpagemessage;
			
			// get my rights - possible is 0,1,2
			$mypagerights = $knowledgeroot->getPageRights($_SESSION['cid'],$_SESSION['userid']);
			
			if($readonly == 0 && $mypagerights == 2) {
				echo "[<a href=\"index.php?action=newpage\">".$languagetoken[$language]['newpage']."</a>]&nbsp;\n";
				echo "[<a href=\"index.php?action=editpage\">".$languagetoken[$language]['renamepage']."</a>]&nbsp;\n";
				
				if($_SESSION['cid'] != "1") {
					echo "[<a href=\"#\" onclick=\"window.document.forms.move.move.value='move'; window.open('move.php','Knowledgeroot','width=310,height=400,menubar=yes,resizable=no');\">".$languagetoken[$language]['movepage']."</a>]&nbsp;\n";
					echo "[<a href=\"index.php?delpage=".$_SESSION['cid']."\" onclick=\"return confirm('" . $languagetoken[$language]['delpageask'] . "');\">".$languagetoken[$language]['delpage']."</a>]&nbsp;\n";
				}
				
				echo "[<a href=\"index.php?action=newcontent\">".$languagetoken[$language]['newcontent']."</a>]\n<br><hr><br>";
			}
			
			//check if userid and groupid is set, if not set to 0
			if($_SESSION['userid'] == "" || $_SESSION['groupid'] == "") {
				$_SESSION['userid'] = 0;
				$_SESSION['groupid'] = 0;
			}
			
			// select the content in table content with userrights
			$res = $db->query("SELECT id,content FROM content WHERE belongs_to='".$_SESSION['cid']."' AND deleted=0 AND ((otherrights > 0) OR (\"group\"='".$_SESSION['groupid']."' AND grouprights > 0) OR (owner='".$_SESSION['userid']."' AND userrights>0))");
			$anz = $db->num_rows($res);
			
			// check if some table is on the page
			if($anz != 0) {
				while($row = $db->fetch_assoc($res)) {
					$mycontentrights = $knowledgeroot->getContentRights($row['id'],$_SESSION['userid']);
					
					echo "<a name=\"" . $row['id'] . "\"></a>\n";
					//echo "<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" style=\"border:1px solid black; padding:5px; background-color:#ffffff;\"><tr><td>";
					echo $row['content'];
					echo "<br><br>\n";
					if($dbtype == "pgsql") {
						$result = $db->query("SELECT *, to_char(date,'DD. Mon YYYY HH24:MI:SS') AS dateform FROM files WHERE belongs_to='".$row['id']."' AND deleted=0 ORDER BY id ASC");
					} else {
						$result = $db->query("SELECT *, DATE_FORMAT(date,'%d. %M %Y %H:%i:%s') AS dateform FROM files WHERE belongs_to='".$row['id']."' AND deleted=0 ORDER BY id ASC");
					}
					
					while($zeile = $db->fetch_assoc($result)) {
						$title = "";
						if($zeile['owner'] == NULL || $zeile['owner'] == 0 || $zeile['owner'] == "") {
							$title = $zeile['dateform'];
						} else {
							$title = $knowledgeroot->getOwner($zeile['owner']) . " - " . $zeile['dateform'];
						}
						
						if($readonly == 0 && $mycontentrights == 2) {
							echo "<a href=\"index.php?delfile=".$zeile['id']."\"><img src=\"images/delete.gif\" alt=\"".$languagetoken[$language]['del']."\" height=\"16\" width=\"16\" border=\"0\"></a>&nbsp;<a href=\"index.php?download=".$zeile['id']."\" title=\"".$title."\"><img border=\"0\" src=\"images/file.gif\">".$zeile['filename']."</a>&nbsp;<font class=\"text\">[".getfilesize($zeile['filesize'])."]</font><br>\n";
						} else {
							echo "<a href=\"index.php?download=".$zeile['id']."\" title=\"".$title."\"><img border=\"0\" src=\"images/file.gif\">".$zeile['filename']."</a>&nbsp;<font class=\"text\">[".getfilesize($zeile['filesize'])."]</font><br>\n";
						}
					}
					
					if($readonly == 0 && $mycontentrights == 2) {
						echo "<br>\n[<a href=\"index.php?eid=".$row['id']."\">".$languagetoken[$language]['editcontent']."</a>]&nbsp;\n";
						echo "[<a href=\"index.php?delid=".$row['id']."\" onclick=\"return confirm('" . $languagetoken[$language]['delete'] . "');\">".$languagetoken[$language]['delcontent']."</a>]&nbsp;\n";
						echo "[<a href=\"#\" onclick=\"window.document.forms.move.contentid.value='".$row['id']."'; window.document.forms.move.move.value='cmove'; window.open('move.php','Knowledgeroot','width=310,height=400,menubar=yes,resizable=no');\">".$languagetoken[$language]['movecontent']."</a>]\n<br><br>\n";
	
						echo "<b>".$languagetoken[$language]['addfile']."</b>\n<form action=\"index.php\" method=\"post\" enctype=\"multipart/form-data\">\n<input type=\"hidden\" name=\"upload\" value=\"yes\"><input type=\"hidden\" name=\"contentid\" value=\"".$row['id']."\"><input type=\"file\" name=\"datei\">&nbsp;\n<input type=\"submit\" name=\"submit\" value=\"".$languagetoken[$language]['add']."\"></form><br><div style=\"float:right;\">[&nbsp;<a href=\"#top\" alt=\"" . $languagetoken[$language]['topdescription'] . "\">".$languagetoken[$language]['top']."</a>&nbsp;]</div><br><hr><br>\n";
	
					} else {
						echo "<div style=\"float:right;\">[&nbsp;<a href=\"#top\" alt=\"" . $languagetoken[$language]['topdescription'] . "\">".$languagetoken[$language]['top']."</a>&nbsp;]</div><br><hr>";
					}
					//echo "</td></tr></table>";
				}
				
				if($readonly == 0 && $mypagerights == 2) {
					echo "[<a href=\"index.php?action=newpage\">".$languagetoken[$language]['newpage']."</a>]&nbsp;\n";
					echo "[<a href=\"index.php?action=editpage\">".$languagetoken[$language]['renamepage']."</a>]&nbsp;\n";
				
					if($_SESSION['cid'] != "1") {
						echo "[<a href=\"#\" onclick=\"window.document.forms.move.move.value='move'; window.open('move.php','Knowledgeroot','width=310,height=400,menubar=yes,resizable=no');\">".$languagetoken[$language]['movepage']."</a>]&nbsp;\n";
						echo "[<a href=\"index.php?delpage=".$_SESSION['cid']."\" onclick=\"return confirm('" . $languagetoken[$language]['delpageask'] . "');\">".$languagetoken[$language]['delpage']."</a>]&nbsp;\n";
					}
				
					echo "[<a href=\"index.php?action=newcontent\">".$languagetoken[$language]['newcontent']."</a>]\n<br><br>";
				}
			} else {
				echo "<h3>" . $languagetoken[$language]['nocontent'] . "</h3>\n";
			}

			// form for move page
	                echo "<form name=\"move\" action=\"index.php\" method=\"post\">\n";
                	echo "<input type=\"hidden\" name=\"move\" value=\"move\">\n";
        	        echo "<input type=\"hidden\" name=\"to\" value=\"".$_SESSION['cid']."\">\n";
			echo "<input type=\"hidden\" name=\"contentid\" value=\"\">\n"; // use for move pagecontent
	                echo "</form>\n";

		
		} else {
			echo "<div class=\"welcome\">".$languagetoken[$language]['welcome']."</div>\n";
		}
	}
?>
 </td>
</tr>
</table>

<?php
	$_SESSION['firstrun'] = "yes";
	$db->close();
?>
</body>
</html>
